//+-------------------------------------------------------------------------------------+
//|                                                                      Scalper_M1.mq4 |
//|                                                                                 hoz |
//|                                                                                     |
//+-------------------------------------------------------------------------------------+
#property copyright "hoz"
#property link      ""

extern string ___H0 = " ________  fast ________ ";
extern int     i_maFastTF = 5,
               i_maFastPeriod = 10,
               i_maFastShift = 0,
               i_maFastMethod = MODE_EMA,
               i_maFastApplied = MODE_CLOSE,
               i_maFastIndex = 0;
extern string ___H1 = " ________  slow ________ ";
extern int     i_maSlowTF = 5,
               i_maSlowPeriod = 21,
               i_maSlowShift = 0,
               i_maSlowMethod = MODE_EMA,
               i_maSlowApplied = MODE_CLOSE,
               i_maSlowIndex = 0;
extern string ___H2 = " ________  filtr _______ ";
extern int     i_maFiltrTF = 5,
               i_maFiltrPeriod = 50,
               i_maFiltrShift = 0,
               i_maFiltrMethod = MODE_SMA,
               i_maFiltrApplied = MODE_CLOSE,
               i_maFiltrIndex = 0;
extern string ___H3 = " _______  PA ______ ";
extern int     i_AnyBarsToHistory = 30,                      //         
               i_sequentBarsount = 3;                      //     
extern double  i_sizeOfSequentialCorrectionBar = 0.1,        //       
               i_sizeOfTrandBar = 0.1;                       //  ,     
extern string ___H4 = " ________   ________ ";
extern double  i_thresholdToUp = 1,                          //  
               i_thresholdToDown = 1,                        //  
               i_sl = 10,
               i_tp = 10;
extern string ___H5 = " ________   ________ ";
extern int     i_magic = 3333021;

//   
double g_spread,
       g_stopLevel,
       g_tickSize;
//   
datetime lastBarTime;                                        //    
double pt;
int ticket,
    type,
    g;                                                       //     

#define SIGNAL_NO                            -1              //  
#define SIGNAL_BUY                            0              //   
#define SIGNAL_SELL                           1              //   

#define CROSS_NO                             -1              //    
#define CROSS_UP                              0              //      
#define CROSS_DN                              1              //      

#define REQUIRED_SEQUENTIAL_BULLS_GOT         0              //        
#define REQUIRED_SEQUENTIAL_BEARS_GOT         1              //        

#include <HozIncludeToScalper_M1.mqh>

//+-------------------------------------------------------------------------------------+
//|                                                         |
//+-------------------------------------------------------------------------------------+
int init()
{
   if(Digits == 2 || Digits == 4)
      pt = Point;
   if(Digits == 1 || Digits == 3 || Digits == 5)
      pt = Point*10;
   if(Digits == 6)
      pt = Point*100;
   if(Digits == 7)
      pt = Point*1000;
   
   lastBarTime = 0;
   
   GetMarketInfo();
    
   return (0);
}
//+-------------------------------------------------------------------------------------+
//|                                                       |
//+-------------------------------------------------------------------------------------+
int deinit()
{

   return (0);
}
//+-------------------------------------------------------------------------------------+
//|                                                                   |
//+-------------------------------------------------------------------------------------+
void GetMarketInfo()
{
   g_spread = MarketInfo(Symbol(),MODE_SPREAD) * Point;
   g_stopLevel = MarketInfo(Symbol(),MODE_STOPLEVEL)  * Point;
   g_tickSize = MarketInfo(Symbol(),MODE_TICKSIZE);
}
//+-------------------------------------------------------------------------------------+
//|                                                               |
//+-------------------------------------------------------------------------------------+
bool OpenBuy()
{
   int ticket = -1;
   double OOP = High[1] + i_thresholdToUp * pt;
   pr ("ND(OOP) = " + ND(OOP) + " ; Ask = " + Ask);

   if (ND(OOP)> (Ask))
       ticket = OrderSend(Symbol(), OP_BUYSTOP, 0.1, ND(OOP), 30, 0, 0, NULL, i_magic, 0, CLR_NONE);
   else
       pr ("OpenBuy():       ");
   
   if (ticket > 0)
   {
       return (true);
   }
   else
       pr ("OpenBuy():     " + GetLastError());
   
   return (false);
}
//+-------------------------------------------------------------------------------------+
//|                                                              |
//+-------------------------------------------------------------------------------------+
bool OpenSell()
{
   int ticket = -1;
   double OOP = Low[1] - i_thresholdToDown * pt;
      
   if (ND(OOP) < Bid)
       ticket = OrderSend(Symbol(), OP_SELLSTOP, 0.1, ND(OOP), 30, 0, 0, NULL, i_magic, 0, CLR_NONE);
   else
       pr ("OpenSell():       ");

   if (ticket > 0)
   {
       return (true);
   }
   else
       pr ("OpenSell():     " + GetLastError());
   
   return (false);
}
//+-------------------------------------------------------------------------------------+
//|                                                                      |
//+-------------------------------------------------------------------------------------+
bool Trade (int signal)
{
   if (signal == SIGNAL_BUY)
       if (!OpenBuy())
          return (false);
          
   if (signal == SIGNAL_SELL)
       if (!OpenSell())
          return (false);

   return (true);
}
//+-------------------------------------------------------------------------------------+
//|                            |
//+-------------------------------------------------------------------------------------+
int LastCandlesType(int directionMA)
{
   int cntUp,                                                                           //       ..
       cntDn;                                                                           // ..  
       
   for (int i=i_AnyBarsToHistory; i>=1; i--)
   {
      if (directionMA == CROSS_UP)
      {
         if ((Open[i] - Close[i]) >= i_sizeOfSequentialCorrectionBar * pt)              //     ..
             cntDn++;                                                                   // ..  1  
         if ((Close[i] - Open[i]) >= i_sizeOfTrandBar * pt)                             //  ,    ..
             cntDn = 0;                                                                 // ..  
                                                                                        
         if (i == 1)
            Print(" directionMA ", directionMA, "; i = ", i, "; Open[i] - Close[i] = ", Open[i] - Close[i], "; cntDn = ", cntDn);

         if (cntDn == i_sequentBarsount)                                                //  cnt    ..
             return (REQUIRED_SEQUENTIAL_BEARS_GOT);                                     // ..   
      }

      if (directionMA == CROSS_DN)
      {
         if ((Close[i] - Open[i]) >= i_sizeOfSequentialCorrectionBar * pt)              //     ..
             cntUp++;                                                                   // ..  1  
         if ((Open[i] - Close[i]) >= i_sizeOfTrandBar * pt)                             //  ,    ..
             cntUp = 0;                                                                 // ..  
         if (i == 1)
            Print(" directionMA ", directionMA, "; i = ", i, "; Close[i] - Open[i] = ", Close[i] - Open[i], "; cntUp = ", cntUp);

         if (cntUp == i_sequentBarsount)                                                //  cnt    ..
             return (REQUIRED_SEQUENTIAL_BULLS_GOT);                                     // ..   
      }
   }
}
//+-------------------------------------------------------------------------------------+
//|                                                   |
//+-------------------------------------------------------------------------------------+
double GetMA(int typeOfMA)
{
   switch (typeOfMA)
   {
      case 1:      return (iMA(NULL, i_maFastTF, i_maFastPeriod, i_maFastShift, i_maFastMethod, i_maFastApplied, i_maFastIndex));
      case 2:      return (iMA(NULL, i_maSlowTF, i_maSlowPeriod, i_maSlowShift, i_maSlowMethod, i_maSlowApplied, i_maSlowIndex));
      case 3:      return (iMA(NULL, i_maFiltrTF, i_maFiltrPeriod, i_maFiltrShift, i_maFiltrMethod, i_maFiltrApplied, i_maFiltrIndex));
   }
}
//+-------------------------------------------------------------------------------------+
//|                                                    |
//+-------------------------------------------------------------------------------------+
int GetStateOfMA()
{
   if (GetMA(1) > GetMA(2))
   {
       pr ("GetStateOfMA() = CROSS_UP");
       return (CROSS_UP);
   }
       
   if (GetMA(1) < GetMA(2))
   {
       pr ("GetStateOfMA() = CROSS_DN");
       return (CROSS_DN);
   }
       
    pr ("GetStateOfMA() = CROSS_NO");
    return (CROSS_NO);
}
//+-------------------------------------------------------------------------------------+
//|                                                          |
//+-------------------------------------------------------------------------------------+
int GetGeneralSignal()
{
   int directionMA = GetStateOfMA();
   
   if (directionMA == CROSS_UP)
   {
       Print("fastMA > slowMA = ", GetMA(1) > GetMA(2));
       if (LastCandlesType(CROSS_UP) == REQUIRED_SEQUENTIAL_BEARS_GOT)
       {
           Print("LastCandlesType(CROSS_UP) = i_sequentBarsount ; ", " LastCandlesType(CROSS_UP) = ", i_sequentBarsount);
           return (SIGNAL_BUY);
       }
   }
           
   if (directionMA == CROSS_DN)
   {
       Print("fastMA < slowMA = ", GetMA(1) < GetMA(2));
       if (LastCandlesType(CROSS_DN) == REQUIRED_SEQUENTIAL_BULLS_GOT)
       {
           Print("LastCandlesType(CROSS_DN) = i_sequentBarsount ; ", " LastCandlesType(CROSS_DN) = ", i_sequentBarsount);
           return (SIGNAL_SELL);
       }
   }
   
   return (SIGNAL_NO);
}
//+-------------------------------------------------------------------------------------+
//|  start                                                               |
//+-------------------------------------------------------------------------------------+
int start()
{
   if (lastBarTime == Time[0])         //      ..
       return (0);                               // ..  
       
   int signal = GetGeneralSignal();
   
   if (signal != SIGNAL_NO)
       if (!Trade(signal))
          return (0);

   lastBarTime = Time[0];               //      ..
                                            // ..  
   return (0);
}